
#property copyright " 2011 BJF Trading Group"
#property link      "www.iticsoftware.com"

#define vers   "1.2.1"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_width1 1
#property indicator_color2 Pink
#property indicator_width2 1
#property indicator_color3 Yellow
#property indicator_width3 1

extern int MA_TF1 = PERIOD_H1;
extern int MA_Period1 = 10;
extern int MA_Shift1 = 0;
extern int MA_Method1 = MODE_SMA;
extern int MA_applied_price1 = PRICE_CLOSE;
extern int MA_TF2 = PERIOD_H1;
extern int MA_Period2 = 40;
extern int MA_Shift2 = 0;
extern int MA_Method2 = MODE_SMA;
extern int MA_applied_price2 = PRICE_CLOSE;
extern int MA_TF3 = PERIOD_H1;
extern int MA_Period3 = 240;
extern int MA_Shift3 = 0;
extern int MA_Method3 = MODE_SMA;
extern int MA_applied_price3 = PRICE_CLOSE;

double MABuf[];
double MABuf2[];
double MABuf3[];

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void init()
{
  SetIndexBuffer(0, MABuf);
  SetIndexStyle(0, DRAW_LINE);
  SetIndexEmptyValue(0, 0.0);
  SetIndexDrawBegin(0, MA_Period1);
  SetIndexBuffer(1, MABuf2);
  SetIndexStyle(1, DRAW_LINE);
  SetIndexEmptyValue(1, 0.0);
  SetIndexDrawBegin(1, MA_Period2);
  SetIndexBuffer(2, MABuf3);
  SetIndexStyle(2, DRAW_LINE);
  SetIndexEmptyValue(2, 0.0);
  SetIndexDrawBegin(2, MA_Period3);
  IndicatorShortName( "MTFMA("+string_periodz(MA_TF1)+"@"+MA_Period1+","+string_periodz(MA_TF2)+"@"+MA_Period2+","+string_periodz(MA_TF3)+"@"+MA_Period3+")");
  //IndicatorShortName("Stochastic 3("+KPer+","+SlPer+","+DPer+","+string_(per1)+","+string_(per2)+","+string_(per3)+")");
}   
string string_periodz(int per)
{
   if (per == 1)     return("M1");
   if (per == 5)     return("M5");
   if (per == 15)    return("M15");
   if (per == 30)    return("M30");
   if (per == 60)    return("H1");
   if (per == 240)   return("H4");
   if (per == 1440)  return("D1");
   if (per == 10080) return("W1");
   if (per == 43200) return("MN1");
   return("WTF");
   }
   
void deinit()
{
}

void start()
{
  int counted_bars = IndicatorCounted();
  if(counted_bars < 0) return;
  if(counted_bars > 0) counted_bars--;
  int limit = Bars-counted_bars;
  limit += MA_TF1/Period();
  for (int i=limit; i >= 0; i--)
  {
    int shift = iBarShift(NULL, MA_TF1, Time[i], true);
    if (shift == -1) continue;
    
    MABuf[i] = iMA(NULL, MA_TF1, MA_Period1, MA_Shift1, MA_Method1, MA_applied_price1, shift);
  }
  int counted_bars2 = IndicatorCounted();
  if(counted_bars2 < 0) return;
  if(counted_bars2 > 0) counted_bars2--;
  int limit2 = Bars-counted_bars2;
  limit += MA_TF2/Period();
  for (int i2=limit2; i2 >= 0; i2--)
  {
    int shift2 = iBarShift(NULL, MA_TF2, Time[i2], true);
    if (shift2 == -1) continue;
    
    MABuf2[i2] = iMA(NULL, MA_TF2, MA_Period2, MA_Shift2, MA_Method2, MA_applied_price2, shift2);
  }
  int counted_bars3 = IndicatorCounted();
  if(counted_bars3 < 0) return;
  if(counted_bars3 > 0) counted_bars3--;
  int limit3 = Bars-counted_bars3;
  limit += MA_TF3/Period();
  for (int i3=limit3; i3 >= 0; i3--)
  {
    int shift3 = iBarShift(NULL, MA_TF3, Time[i3], true);
    if (shift3 == -1) continue;
    
    MABuf3[i3] = iMA(NULL, MA_TF3, MA_Period3, MA_Shift3, MA_Method3, MA_applied_price3, shift3);
  }
}